/**
 * Logger class - exported as a singleton
 * @class
 */
declare class Logger {
    private _disable;
    constructor(disable?: boolean);
    /**
     * Disable the logger by setting disable to true
     * @param {boolean} val - The value for the disable setting
     */
    set disable(v: boolean);
    /**
     * info
     */
    info(val: string | Record<string, unknown>): void;
    /**
     * body
     */
    body(val: string | Record<string, unknown>): void;
    /**
     * success
     */
    success(val: string | Record<string, unknown>): void;
    /**
     * warn
     */
    warn(val: string | Record<string, unknown>): void;
    /**
     * error
     */
    error(val: string | Record<string, unknown>): void;
}
declare const log: Logger;
export default log;
