"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
/**
 * Logger class - exported as a singleton
 * @class
 */
class Logger {
    constructor(disable = false) {
        this._disable = disable;
    }
    /**
     * Disable the logger by setting disable to true
     * @param {boolean} val - The value for the disable setting
     */
    set disable(v) {
        this._disable = v;
    }
    /**
     * info
     */
    info(val) {
        !this._disable && console.log(chalk_1.default.cyan(val));
    }
    /**
     * body
     */
    body(val) {
        !this._disable && console.dir(val, { depth: Infinity });
    }
    /**
     * success
     */
    success(val) {
        !this._disable && console.log(chalk_1.default.green(val));
    }
    /**
     * warn
     */
    warn(val) {
        !this._disable && console.warn(chalk_1.default.yellow(val));
    }
    /**
     * error
     */
    error(val) {
        !this._disable && console.error(chalk_1.default.red(val));
    }
}
const log = new Logger();
exports.default = log;
//# sourceMappingURL=logger.js.map